import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class Bee extends Animal
{
    /**
     * Act - do whatever the Bee wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if ( atWorldEdge() )
        {
            //turn(17);
        }
        turnRandom();
        lookForButterfly();
        wrapAtEdge();
    }    
    
    /**
     * Turn either right or left, randomly chosen.
     */
    public void turnRandom()
    {
        move(5);
        if (Greenfoot.getRandomNumber(2) == 0) {
            turn(10);
        }
        else {
            turn(-10);
        }
    }
    
    /**
     * Check whether we have stumbled upon a Butterfly.
     * If we have, kill it. If not, do nothing.
     */
    public void lookForButterfly()
    {
        if ( canSee(Butterfly.class) ) 
        {
            eat(Butterfly.class);
            Greenfoot.setWorld(new LoseScreen());
        }
    }
    
    /**
     * Return true if we can see an object of class 'clss' right where we are. 
     * False if there is no such object here.
     */
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }

    
    /**
     * Try to eat an object of class 'clss'. This is only successful if there
     * is such an object where we currently are. Otherwise this method does
     * nothing.
     */
    public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
    
    /**
     * Test if we are close to one of the edges of the world. Return true is we are.
     */
    public boolean atWorldEdge()
    {
        if(getX() < 20 || getX() > getWorld().getWidth() - 20)
            return true;
        if(getY() < 20 || getY() > getWorld().getHeight() - 20)
            return true;
        else
            return false;
    }
    
}
