import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class Butterfly extends Animal
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    private GreenfootImage image3;
    private GreenfootImage image4;
    
    int switchDelay = 0;
     
    public Butterfly()
    {
        image1 = new GreenfootImage("butterfly.png");
        image2 = new GreenfootImage("butterfly2.png");
        image3 = new GreenfootImage("butterfly3.png");
        image4 = new GreenfootImage("butterfly4.png");
        setImage(image1);
    }
    
    /**
     * Do what a Butterfly's gotta do. (Which is: mostly flying about, and turning.)
     */
    public void act()
    {
        checkKeys();
        switchImage();
        wrapAtEdge();
    }
    
    public void switchImage()
    {
        switchDelay++;
        if ( switchDelay%3 == 0)
        {
          if (getImage() == image1)
          {
              setImage(image2);
          }
          else if (getImage() == image2)
          {
              setImage(image3);
          }
          else if (getImage() == image3)
          {
              setImage(image4);
          }
          else if (getImage() == image4)
          {
              setImage(image1);
          }
        }
    }
    
    public void wait(int time)  
    {  
       Greenfoot.delay(time);  
    }  

    /**
     * set rotation by pressing the left or right keys.
     */
    private void checkKeys()
    {
        if(Greenfoot.isKeyDown("left"))
        {setRotation(getRotation()-10);
        }
        
        if(Greenfoot.isKeyDown("right"))
        {setRotation(getRotation()+10);
        }
        
        if(Greenfoot.isKeyDown("up"))
        {
            move(5);
        }
        
        if(Greenfoot.isKeyDown("down"))
        {
            move(-5);
        }
    }
    
    /**
     * Return true if we can see an object of class 'clss' right where we are. 
     * False if there is no such object here.
     */
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
    
    
}